#!/usr/bin/perl
##############################################################################
##
##   $Id: rptMonthlySummary.pl,v 1.2 2004/04/03 14:04:53 croftj Exp $
##   Copyright (c) 2004 Joe Croft <joe@croftj.net>
##   
##   This file is part of ah2.
##
##   ah2 is free software; you can redistribute it and/or modify
##   it under the terms of the GNU General Public License as published by
##   the Free Software Foundation; either version 2 of the License, or
##   (at your option) any later version.
##
##   Foobar is distributed in the hope that it will be useful,
##   but WITHOUT ANY WARRANTY; without even the implied warranty of
##   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##   GNU General Public License for more details.
##
##   You should have received a copy of the GNU General Public License
##   along with Foobar; if not, write to the Free Software
##   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##############################################################################
#
#title:Monthly Summary::date:
#arg:Beg. Date:beg:date:
#arg:End  Date:end:date:
#arg:Type:type:selection:Month To Date-mtod,Year to Date-ytod,Month of-mon,Beg. date to End date-none,Year End-year_end
#arg:Monthly Breakdown:monthly:checkbox:
#arg:Detailed Report:detailed:checkbox:

use DBI;

use Reports;

$| = 1;

my $rpt = new Reports(\@ARGV, "-P -l");
$dbh = $rpt->openDatabase();
$dbh->do("set datestyle='SQL'");
my ($beg, $end) = $rpt->getDateSpan();

my $out_format = $rpt->{out_format};

if ( $out_format eq "ps") {
   $out = <<END;
.ll 10.0i
.pl 7.5i
.po .5i
.m1 .25i
.m2 .25i
.m3 .25i
.m4 0i
.sz +5
.ce 3
.b "$rpt->{title}"
.br
.b "$rpt->{type} Report"
.br
$beg to $end
.sz -5

.he '$rpt->{type} report'$rpt->{title}'$beg to $end'
.fo ''%''
END
   $rpt->print_rpt($out);
}
else {
   $out = <<END;
<qt bgcolor="#ffffff">
   <center>
      <h1>$rpt->{title}</h1>
      <h2>$rpt->{type} Report</h2>
      <h2>$beg to $end</h2>
END
   $rpt->print_rpt($out);
}

$body = "";
if ( $out_format eq "ps") {
   $out = <<END;
.ce
.sz +3
.b "$rpt->{type} Totals"
.sz -3

.TS H
expand tab(;);
cb cb cb cb cb cb cb cb cb cb | cb
l l n n n n n n n n | nb.
Begin;End;Parts;Taxable;Supplies;Taxable;Parts Total;Labor Total;Haz. Mat.;Sales Tax;Total
_
.TH
END
   $rpt->print_rpt($out);
}
else {
   $out = <<END;
<center><h4>$rpt->{type} Totals</h4></center>
<table width="100%">
<tr>
   <th align="right"><b>Beg.</b></th>
   <th align="right"><b>End</b></th>
   <th align="right"><b>Parts</b></th>
   <th align="right"><b>Parts Taxable</b></th>
   <th align="right"><b>Supplies</b></th>
   <th align="right"><b>Supplies Taxable</b></th>
   <th align="right"><b>Parts Total</b></th>
   <th align="right"><b>Labor Total</b></th>
   <th align="right"><b>Haz. Mat.</b></th>
   <th align="right"><b>Sales Tax</b></th>
   <th align="right"><b>Total</b></th>
</tr>
END
   $rpt->print_rpt($out);
}

($date1, $date2) = $rpt->getDateSpan();
$b = summary("$date1", "$date2");
$body .= $b;
if ( $out_format eq "ps" ) {
   $body .= <<END;
.TE
END
}
else {
   $body .= <<END;
</table>
END
}

if ( $rpt->{monthly} > 0 ) {
   if ( $out_format eq "ps") {
      $body .= <<END;
.ce
.sz +3
.b "Monthly Summaries"
.sz -3

.TS H
expand tab(;);
cb cb cb cb cb cb cb cb cb cb | cb
l l n n n n n n n n | nb.
Begin;End;Parts;Taxable;Supplies;Taxable;Parts Total;Labor Total;Haz. Mat.;Sales Tax;Total
_
.TH
END
#Begin;End;Parts Nontaxable;Parts Taxable;Parts;Labor;Haz. Mat.;Sales Tax;Total
#Begin;End;a;b;c;d;f;g;Total
   }
   else {
      $body .= <<END;
<center><h4>Monthly Summaries</h4></center>
<table width="100%">
<tr>
   <th align="right"><b>Beg.</b></th>
   <th align="right"><b>End</b></th>
   <th align="right"><b>Parts</b></th>
   <th align="right"><b>Parts Taxable</b></th>
   <th align="right"><b>Supplies</b></th>
   <th align="right"><b>Supplies Taxable</b></th>
   <th align="right"><b>Parts</b></th>
   <th align="right"><b>Labor</b></th>
   <th align="right"><b>Haz. Mat.</b></th>
   <th align="right"><b>Sales Tax</b></th>
   <th align="right"><b>Total</b></th>
</tr>
END
   }
   while (1) {
      my ($date1, $date2, $done) = $rpt->getNextMonth();
      print STDERR "Done = $done\n";
      if ( $done > 0 ) {
         last;
      }
      $b = summary("$date1", "$date2");
      $body .= $b;
   }
   if ( $out_format eq "ps") {
      $body .= <<END;
.TE
END
   }
   else {
      $body .= <<END;
</table>
END
   }
}
$rpt->print_rpt("$body\n");
$body = "";

if ( $rpt->{detailed} > 0 ) {
   if ( $out_format eq "ps") {
      $body = <<END;
.ce
.sz +3
.b "Details"
.sz -3
.TS H
expand tab(;);
cb cb cb cb cb cb | cb
l l n n n n | nb.
Invoice;Date Out;Parts;Labor Total;Haz. Mat.;Sales Tax;Total
_
.TH
END
   }
   else {
      $body = <<END;
<p>
<center><h4>Details</h4></center>
<table width="100%">
<tr>
   <th align="right"><b>Invoice</b></th>
   <th align="right"><b>Date Out</b></th>
   <th align="right"><b>Parts</b></th>
   <th align="right"><b>Labor</b></th>
   <th align="right"><b>Haz. Mat.</b></th>
   <th align="right"><b>Sales Tax</b></th>
   <th align="right"><b>Total</b></th>
</tr>
END
   }
   $rpt->print_rpt("$body\n");
   $body = "";
   ($date1, $date2) = $rpt->getDateSpan();
   $sql = "select ident, date_out, parts, labor, hazmat, tax, total from workorders where " .
               "date_out >= '$date1' and date_out <= '$date2' and workorders.closed = 'Y' order by date_out";
   print STDERR "$sql\n";
   $sth = $dbh->prepare($sql) || die;
   $sth->execute() || die;
   while (($r = $sth->fetchrow_arrayref) ne undef) {
      $invoice    = $r->[0];
      $date_out   = $r->[1];
      $parts      = $rpt->fmt_money($r->[2]);
      $labor      = $rpt->fmt_money($r->[3]);
      $hazmat     = $rpt->fmt_money($r->[4]);
      $tax        = $rpt->fmt_money($r->[5]);
      $total      = $rpt->fmt_money($r->[6]);
      ($date_out, $x, $x) = split / +/, $date_out;
      if ( $out_format eq "ps") {
         $body .= "$invoice;$date_out;$parts;$labor;$hazmat;$tax;$total\n";
      }
      else {
         $body .= <<END;
<tr>
   <th align="left">$invoice</th>
   <th align="left">$date_out</th>
   <th align="right">$parts</th>
   <th align="right">$labor</th>
   <th align="right">$hazmat</th>
   <th align="right">$tax</th>
   <th align="right"><b>$total</b></th>
</tr>
END
      }
   }
   $sth->finish;
   if ( $out_format eq "ps") {
      $body .= ".TE\n";
   }
   else {
      $body .= <<END;
</table>
END
   }

   $rpt->print_rpt("$body\n");
}

sub summary
{
   my ($beg, $end) = @_;

   my $b = "";
   my $sql = "select cast(sum(cost * cast(qty as numeric)) as numeric(15,2)) from wo_parts, workorders where " .
                  "supply = 'N' and date_out >= '$beg' and date_out <= '$end' and " .
                  "wo_parts.workorder = workorders.ident and workorders.closed = 'Y'";
   my $sth = $dbh->prepare($sql);
   $sth->execute();
   if ( ($r = $sth->fetchrow_arrayref) ne undef ) {
      $parts = $rpt->fmt_money($r->[0]);
   }
   $sth->finish;

   $sql = "select cast(sum(cost * cast(qty as numeric)) as numeric(15,2)) from wo_parts, workorders where " .
                  "supply = 'N' and taxable = 'Y' and date_out >= '$beg' and date_out <= '$end' and " .
                  "wo_parts.workorder = workorders.ident and workorders.closed = 'Y'";
   $sth = $dbh->prepare($sql);
   $sth->execute();
   if ( ($r = $sth->fetchrow_arrayref) ne undef ) {
      $taxable_parts = $rpt->fmt_money($r->[0]);
   }
   $sth->finish;

   $sql = "select cast(sum(cost * cast(qty as numeric)) as numeric(15,2)) from wo_parts, workorders where " .
                  "supply = 'Y' and date_out >= '$beg' and date_out <= '$end' and " .
                  "wo_parts.workorder = workorders.ident and workorders.closed = 'Y'";
   $sth = $dbh->prepare($sql);
   $sth->execute();
   if ( ($r = $sth->fetchrow_arrayref) ne undef ) {
      $supplies = $rpt->fmt_money($r->[0]);
   }
   $sth->finish;

   $sql = "select cast(sum(cost * cast(qty as numeric)) as numeric(15,2)) from wo_parts, workorders where " .
                  "supply = 'Y' and taxable = 'Y' and date_out >= '$beg' and date_out <= '$end' and " .
                  "wo_parts.workorder = workorders.ident and workorders.closed = 'Y'";
   $sth = $dbh->prepare($sql);
   $sth->execute();
   if ( ($r = $sth->fetchrow_arrayref) ne undef ) {
      $taxable_supplies = $rpt->fmt_money($r->[0]);
   }
   $sth->finish;
   
   $sql = "select cast(sum(parts) as numeric(15,2)) from workorders where " .
                  "date_out >= '$beg' and date_out <= '$end' and workorders.closed = 'Y'";
   $sth = $dbh->prepare($sql);
   $sth->execute();
   if ( ($r = $sth->fetchrow_arrayref) ne undef ) {
      $parts_total = $rpt->fmt_money($r->[0]);
   }
   $sth->finish;
   
   $sql = "select cast(sum(labor) as numeric(15,2)) from workorders where " .
                  "date_out >= '$beg' and date_out <= '$end' and workorders.closed = 'Y'";
   $sth = $dbh->prepare($sql);
   $sth->execute();
   if ( ($r = $sth->fetchrow_arrayref) ne undef ) {
      $labor_total = $rpt->fmt_money($r->[0]);
   }
   $sth->finish;
   
   $sql = "select cast(sum(hazmat) as numeric(15,2)) from workorders where " .
                  "date_out >= '$beg' and date_out <= '$end' and workorders.closed = 'Y'";
   $sth = $dbh->prepare($sql);
   $sth->execute();
   if ( ($r = $sth->fetchrow_arrayref) ne undef ) {
      $hazmat = $rpt->fmt_money($r->[0]);
   }
   $sth->finish;
   
   $sql = "select cast(sum(tax) as numeric(15,2)) from workorders where " .
                  "date_out >= '$beg' and date_out <= '$end' and workorders.closed = 'Y'";
   $sth = $dbh->prepare($sql);
   $sth->execute();
   if ( ($r = $sth->fetchrow_arrayref) ne undef ) {
      $tax = $rpt->fmt_money($r->[0]);
   }
   $sth->finish;
   
   $sql = "select cast(sum(total) as numeric(15,2)) from workorders where " .
                  "date_out >= '$beg' and date_out <= '$end' and workorders.closed = 'Y'";
   $sth = $dbh->prepare($sql);
   $sth->execute();
   if ( ($r = $sth->fetchrow_arrayref) ne undef ) {
      $total = $rpt->fmt_money($r->[0]);
   }
   $sth->finish;
   if ( $out_format eq "ps") {
      $b = "$beg;$end;$parts;$taxable_parts;$supplies;$taxable_supplies;$parts_total;$labor_total;$hazmat;$tax;$total\n";
   }
   else {
      $b = <<END;
<tr>
   <th align="left">$beg</th>
   <th align="left">$end</th>
   <th align="right">$parts</th>
   <th align="right">$taxable_parts</th>
   <th align="right">$supplies</th>
   <th align="right">$taxable_supplies</th>
   <th align="right">$parts_total</th>
   <th align="right">$labor_total</th>
   <th align="right">$hazmat</th>
   <th align="right">$tax</th>
   <th align="right"><b>$total</b></th>
</tr>
END
   }
   return($b);
}
