#!/usr/bin/perl
##############################################################################
##
##   $Id: rptRevenuExpense.pl,v 1.3 2004/05/04 01:05:00 croftj Exp $
##   Copyright (c) 2004 Joe Croft <joe@croftj.net>
##   
##   This file is part of ah2.
##
##   ah2 is free software; you can redistribute it and/or modify
##   it under the terms of the GNU General Public License as published by
##   the Free Software Foundation; either version 2 of the License, or
##   (at your option) any later version.
##
##   Foobar is distributed in the hope that it will be useful,
##   but WITHOUT ANY WARRANTY; without even the implied warranty of
##   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##   GNU General Public License for more details.
##
##   You should have received a copy of the GNU General Public License
##   along with Foobar; if not, write to the Free Software
##   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##############################################################################
#
#title:Revenue and Expenses::date:
#arg:Beg. Date:beg:date:
#arg:End  Date:end:date:
#arg:Type:type:selection:Month To Date-mtod,Year to Date-ytod,Month of-mon,Beg. date to End date-none,Year End-year_end
#arg:Monthly Breakdown:monthly:checkbox:
#arg:Detailed Report:detailed:checkbox:

use DBI;

use Reports;

$| = 1;

my $rpt = new Reports(\@ARGV);
$dbh = $rpt->openDatabase();

my ($beg, $end) = $rpt->getDateSpan();

my $out_format = $rpt->{out_format};

if ( $out_format eq "ps") {
   $out = <<END;
.sz +5
.ce 3
$rpt->{title}
.br
$rpt->{type} Report
.br
$beg to $end
.sz -5

.he '$rtp->{type} report'$rpt->{title}'$beg to $end'
.fo ''%''
END
   $rpt->print_rpt($out);
}
else {
   $out = <<END;
<qt bgcolor="#ffffff">
   <center>
      <h1>$rpt->{title}</h1>
      <h2>$rpt->{type} Report</h2>
      <h2>$beg to $end</h2>
END
   $rpt->print_rpt($out);
}

$body = "";

if ( $out_format eq "ps") {
   $out = <<END;
.ce
.sz +3
$rpt->{type} Totals
.sz -3

END
   $rpt->print_rpt($out);
}
else {
   $out = <<END;
<center><h4>$rpt->{type} Totals</h4></center>
END
   $rpt->print_rpt($out);
}

($date1, $date2) = $rpt->getDateSpan();
($b, %subtotals) = summary("$date1", "$date2");

print STDERR "\ntotals\n";
foreach $a (sort keys %subtotals) {
   print STDERR "$a => $subtotals{$a}\n";
}

$body .= $b;

if ( $rpt->{monthly} > 0 ) {
   if ( $out_format eq "ps") {
      $body .= <<END;
.ce
.sz +3
Monthly Summaries
.sz -3

END
   }
   else {
      $body .= <<END;
<center><h4>Monthly Summaries</h4></center>
END
   }
   while (1) {
      my (%r, %e);
      my ($date1, $date2, $done) = $rpt->getNextMonth();
      print STDERR "Done = $done\n";
      if ( $done > 0 ) {
         last;
      }
      ($b, %r, %e) = summary("$date1", "$date2");
      $body .= $b;
   }
}
$rpt->print_rpt("$body\n");
$body = "";

if ( $rpt->{detailed} > 0 ) {
   if ( $out_format eq "ps") {
      $out = <<END;
.bp
.ce 1
.sz +3
Account Details
.sz -3
END
      $rpt->print_rpt($out);
   }
   else {
      $out = <<END;
<h4>Account Details</h4>
END
      $rpt->print_rpt($out);
   }
   foreach $acct (sort keys %revenue) {
      if ( $out_format eq "ps") {
         $header = <<END;
.sp 3
.TS H
expand;
l s s rb
l l l nb.
Revenue Account	$acct
_
.TH
END
      }
      else {
         $header = <<END;
<h3>Revenue Account $acct</h3>
<table width="100%">
<tr>
END
      }

      $body = "";
      $sql = "select date_in, amount, type, descr from ledger where account = '$revenue{$acct}' and date_in between '$beg' and '$end' order by date_in, type";
      print STDERR "sql= $sql\n";
      $sth = $dbh->prepare($sql);
      $sth->execute();
      while (($r = $sth->fetchrow_arrayref) ne undef) {
         if ( $r->[2] eq 'DB' ) {
            $r->[1] = "(-$r->[1])";
            $r->[1] *= -1;
         }
         $r->[1] = $rpt->fmt_money($r->[1]);
         if ( $out_format eq "ps") {
            $body .= "$r->[0]	$r->[3]	$r->[2]	$r->[1]\n";
         }
         else {
            $body .= "<tr><th align=\"left\">$r->[0]</th><th align=\"left\">$r->[3]</th><th align=\"left\">$r->[2]</th><th align=\"right\"><b>$r->[1]</b></th></tr>\n";
         }
      }
      my $st = $rpt->fmt_money($subtotals{$acct});
      if ( $out_format eq "ps") {
         $body .= <<END;
_	_	_	_
		Total	$st
.TE
END
      }
      else {
         $body .= <<END;
<tr><th colspan=4><hr width="100%"></th></tr>
<tr><th colspan=4 align="right"><b>Total: $st</b></th></tr>
</table>
END
      }
      $rpt->print_rpt("$header\n$body\n");
      $header = "";
      $body = "";
   }

   foreach $acct (sort keys %expenses) {
      if ( $out_format eq "ps") {
         $header = <<END;
.sp 3
.TS H
expand;
l s s rb
l l l nb.
Expense Account	$acct
_
.TH
END
      }
      else {
         $header = <<END;
<h3>Expense Account $acct</h3>
<table width="100%">
<tr>
END
      }
      $body = "";
      $sql = "select date_in, amount, type, descr from ledger where account = '$expenses{$acct}' and date_in between '$beg' and '$end' order by date_in, type";
#      print STDERR "sql= $sql\n";
      $sth = $dbh->prepare($sql);
      $sth->execute();
      while (($r = $sth->fetchrow_arrayref) ne undef) {
         if ( $r->[2] eq 'CR' ) {
#            $r->[1] = "(-$r->[1])";
            $r->[1] *= -1;
         }
         $r->[1] = $rpt->fmt_money($r->[1]);
         if ( $out_format eq "ps") {
            $body .= "$r->[0]	$r->[3]	$r->[2]	$r->[1]\n";
         }
         else {
            $body .= "<tr><th align=\"left\">$r->[0]</th><th align=\"left\">$r->[3]</th><th align=\"left\">$r->[2]</th><th align=\"right\"><b>$r->[1]</b></th></tr>\n";
         }
      }
      my $st = $rpt->fmt_money($subtotals{$acct});
      if ( $out_format eq "ps") {
         $body .= <<END;
_	_	_	_
		Total	$st
.TE
END
      }
      else {
         $body .= <<END;
<tr><th colspan=4><hr width="100%"></th></tr>
<tr><th colspan=4 align="right"><b>Total: $st</b></th></tr>
</table>
<hr width="50%">
END
      }
      $rpt->print_rpt("$header\n$body\n");
      $header = "";
      $body = "";
   }
}
if ( $out_format ne "ps") {
   $rpt->print_rpt("</qt>\n");
}

sub summary
{
   my ($beg, $end) = @_;

   my (%expenses_subtotals, %revenue_subtotals, $body);

   print STDERR "beg=$beg, end = $end\n";
   $sql = "select ident, name from accounts where revenue = 'Y'";
   print STDERR "sql = |$sql|\n";
   $sth = $dbh->prepare($sql);
   $sth->execute();
   $accts = "";
   while (($r = $sth->fetchrow_arrayref()) ne undef) {
      $revenue{$r->[1]} = $r->[0];
      if ( "$accts" ne "" ) {
         $accts .= ", "
      }
      $accts .= "'$r->[0]'"
   }
   $sth->finish;

   $sql = "select sum(amount * cast(mult as numeric)) from ledger where account in ($accts) and date_in between '$beg' and '$end'";
   print STDERR "sql= $sql\n";
   $sth = $dbh->prepare($sql);
   $sth->execute();
   if (($r = $sth->fetchrow_arrayref()) ne undef) {
      $revenue_total = $rpt->fmt_money($r->[0]);
   }
   print STDERR "Revenues: $revenue_total\n"; 

   $sql = "select ident, name from accounts where expense = 'Y'";
   $sth = $dbh->prepare($sql);


   $sth->execute();
   $accts = "";
   while (($r = $sth->fetchrow_arrayref()) ne undef) {
      $expenses{$r->[1]} = $r->[0];
      if ( "$accts" ne "" ) {
         $accts .= ", "
      }
      $accts .= "'$r->[0]'"
   }
   $sth->finish;

   $sql = "select sum((amount * cast(mult as numeric)) * cast('-1.00' as numeric)) from ledger where account in ($accts) and date_in between '$beg' and '$end'";
   print STDERR "sql= $sql\n";
   $sth = $dbh->prepare($sql);
   $sth->execute();
   if (($r = $sth->fetchrow_arrayref()) ne undef) {
      $expenses_total = $rpt->fmt_money($r->[0]);
   }

   print STDERR "Expenses: $expenses_total\n"; 

   print STDERR "\n\nRevenue\n";
   foreach $acct (sort keys %revenue) {
      $sql = "select sum(amount * cast(mult as numeric)) from ledger where account = '$revenue{$acct}' and date_in between '$beg' and '$end'";
      print STDERR "sql= $sql\n";
      $sth = $dbh->prepare($sql);
      $sth->execute();
      if ( ($r = $sth->fetchrow_arrayref()) ne undef) {
         $revenue_subtotals{$acct} = $r->[0];
      }
      $sth->finish;
   }

   print STDERR "\n\nExpenses\n";
   foreach $acct (sort keys %expenses) {
      $sql = "select sum(amount * cast(mult as numeric) * cast('-1.00' as numeric)) from ledger where account = '$expenses{$acct}' and date_in between '$beg' and '$end'";
      print STDERR "sql= $sql\n";
      $sth = $dbh->prepare($sql);
      $sth->execute();
      if ( ($r = $sth->fetchrow_arrayref()) ne undef) {
         $expenses_subtotals{$acct} = $r->[0];
      }
      $sth->finish;
   }

   if ( $out_format eq "ps") {
      $body = <<END;
.TS H
expand;
cb s s s
cb s|cb s
l nb | l nb.
$beg - $end
Revenue	Expense
_
.TH
END
   }
   else {
      $body .= <<END;
<table cellspacing=0 cellpadding=3 bgcolor="#e0e0ff">
   <tr><th colspan=4><center><b>$beg - $end</b></center></th></tr>
   <tr colspan=2><th colspan=2>Revenue</th><th colspan=2>Expense</th></tr>
END
   }

   $n = 0;
   foreach $acct (sort keys %revenue_subtotals) {
      $accts[$n][0] = "$acct";
      $accts[$n][1] = $rpt->fmt_money($revenue_subtotals{$acct});
      print STDERR "Adding $n $accts[$n][0] => $accts[$n][1]\n";
      $n++;
   }

   $m = 0;
   foreach $acct (sort keys %expenses_subtotals) {
      $accts[$m][2] = "$acct";
      $accts[$m][3] = $rpt->fmt_money($expenses_subtotals{$acct});
      print STDERR "Adding $n $accts[$m][2] => $accts[$m][3]\n";
      $m++;
   }
   $n = ($n > $m) ? $n : $m;
   $accts[$n][0] = "_";
   $accts[$n][1] = "_";
   $accts[$n][2] = "_";
   $accts[$n][3] = "_";
   $n++;
   $accts[$n][0] = "Total:";
   $accts[$n][1] = "$revenue_total";
   $accts[$n][2] = "Total:";
   $accts[$n][3] = "$expenses_total";

   for ($n = 0; $accts[$n][0] ne undef || $accts[$n][2] ne undef; $n++) {
      print STDERR "summary() Adding: |$accts[$n][0], $accts[$n][1], $accts[$n][2], $accts[$n][3]|\n";
      if ( $out_format eq "ps") {
         $body .= "$accts[$n][0]	$accts[$n][1]	$accts[$n][2]	$accts[$n][3]\n";
      }
      else {
         if ( $accts[$n][0] eq "Total:" ) {
            $body .= "<tr><th align=\"left\"><b>$accts[$n][0]</b></th><th align=\"right\"><b>$accts[$n][1]</b></th>";
            $body .= "<th align=\"left\"><b>$accts[$n][2]</b></th><th align=\"right\"><b>$accts[$n][3]</b></th></tr>\n";
         }
         elsif ( $accts[$n][0] eq "_" ) {
            $body .= "<tr><th colspan=4><hr width=\"100%\"</th></tr>\n";
         }
         else {
            $body .= "<tr><th align=\"left\">$accts[$n][0]</th><th align=\"right\"><b>$accts[$n][1]</b></th>";
            $body .= "<th align=\"left\">$accts[$n][2]</th><th align=\"right\"><b>$accts[$n][3]</b></th></tr>\n";
         }
      }
   }
   if ( $out_format eq "ps") {
      $body .= <<END;
.TE
.sp 2
END
   }
   else {
      $body .= <<END;
</table><p><p>
END
   }
   return(($body, %revenue_subtotals, %expenses_subtotals));
}

